import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class AADframe extends JInternalFrame {

CardLayout cl;
JPanel cardPanel;
String selectedHost;
String ApplicationName;

  public AADframe() {
  super("AAD manager", true, true, true, true);
  JPanel bck = new JPanel();
  getContentPane().add(bck);

  bck.setLayout(new BorderLayout());
  JPanel titlePanel = new JPanel();
  titlePanel.setLayout(new GridLayout(3,1));
  titlePanel.add(new JLabel(" "));
  titlePanel.add(new JLabel("Abstract Application Descriptor", JLabel.CENTER));
  titlePanel.add(new JLabel(" "));
  bck.add(titlePanel,BorderLayout.NORTH);

  JPanel AAD = new JPanel();
  AAD.setLayout(new BorderLayout());
  
  JPanel buttons = new JPanel();
  buttons.setLayout(new GridLayout(1,5));
  
  JButton newButton = new JButton("new");
  JButton findButton = new JButton("find");
  JButton viewButton = new JButton("view");
  JButton modifyButton = new JButton("modify");
  JButton commitButton = new JButton("commit");

  ActionListener bl = new ActionListener() {
        public void actionPerformed(ActionEvent ev) {
          showCard(ev.getActionCommand());
        }
  };


   newButton.addActionListener(bl); 
   findButton.addActionListener(bl); 
   viewButton.addActionListener(bl); 
   modifyButton.addActionListener(bl); 
   commitButton.addActionListener(bl); 
 
  buttons.add(newButton);
  buttons.add(findButton);
  buttons.add(viewButton);
  buttons.add(modifyButton);
  buttons.add(commitButton);
  AAD.add(buttons,BorderLayout.NORTH);

  cardPanel = new JPanel();
  cl = new CardLayout();
  cardPanel.setLayout(cl);

  JPanel instrCard = new JPanel();
  instrCard.setLayout(new GridLayout(9,1));

  instrCard.add(new JLabel("This utility allows to create a new ADD",
                            JLabel.CENTER));
  instrCard.add(new JLabel("or modify an existing one", JLabel.CENTER));
  instrCard.add(new JLabel(" "));
  instrCard.add(new JLabel("    To create a new AAD:"));
  instrCard.add(new JLabel("         simply click \"new\" button"));
  instrCard.add(new JLabel("    To modify existing AAD:"));
  instrCard.add(new JLabel("         select ADD using \"find\" button"));
  instrCard.add(new JLabel("         and then use \"modify\" button"));
  instrCard.add(new JLabel("    Use \"commit\" button to save the changes"));

  cardPanel.add("help",instrCard); 
  cl.show(cardPanel,"help");


  /* new application */

  newPanel1 newPanel = new newPanel1(this);
  cardPanel.add("new",newPanel);
  

  JPanel findPanel = new JPanel();
  cardPanel.add("find",findPanel);

  JPanel modifyPanel = new JPanel();
  cardPanel.add("modify",modifyPanel);

  JPanel viewPanel = new JPanel();
  cardPanel.add("view",viewPanel);

  JPanel commitPanel = new JPanel();
  cardPanel.add("commit",commitPanel);


  AAD.add(cardPanel,BorderLayout.CENTER);
  bck.add(AAD,BorderLayout.CENTER);
  }



  public void showCard(String what){
    cl.show(cardPanel,what);
  }

    public void addComponent(java.awt.Container container, Component component,
     int gridx, int gridy, int gridwidth, int gridheight, int fill,
     int anchor, int weight) {
      
     LayoutManager lm =container.getLayout();
     GridBagConstraints gbc = new GridBagConstraints();
     gbc.gridx = gridx;
     gbc.gridy = gridy;
     gbc.gridwidth = gridwidth;
     gbc.gridheight = gridheight;
     gbc.fill = fill;
     gbc.anchor = anchor;
     if(weight>0) {
      gbc.weightx=1.0; 
      gbc.weighty=1.0;
     } 
     container.add(component,gbc);
    }

  public void setSelectedHost(String h) {
     selectedHost = h;
  } 

  public void setApplicationName(String h) {
     ApplicationName = h;
  } 
} 


