import java.net.*;

import java.io.*;

import java.util.*;

import java.util.zip.*;



public class ExeDownload implements Runnable {



URL url;

String USGSurl = "ftp://edcftp.cr.usgs.gov/pub/data/DEM/250/";

String mapName;

int bytes_read, oneread;

InputStream in;

FileOutputStream out;

URLConnection urlcon;

String fileOutName;

mapLoop parent;

boolean updated;



  public ExeDownload(String mapName, mapLoop parent) {

   this.mapName = mapName;

   this.parent = parent;

  }



  public void run() {

      


         /* create URL */




      String cc = mapName.substring(0,1);


      cc = cc.toUpperCase();




      try {

      url = new URL(USGSurl+cc+"/"+mapName+".gz");

      }

      catch(Exception e) {System.err.println("getMap (1) "+e.toString());}




      System.err.println(url.toString());



        /* open connection */




      try{ 



        //String fileOutName="/tmp/"+mapName;

        String fileOutName = "C:\\WMS\\usgsDEM\\"+mapName; 

        out = new FileOutputStream(fileOutName);

      } catch (Exception e) {

          System.err.println(e);

          System.err.println("Cannot open "+fileOutName+" for write");

          }

      try { 

        System.err.println("make connection");

        urlcon = url.openConnection();

      } catch (Exception e) {System.err.println(e);}

      System.err.println("urlcon OK? "+urlcon.toString());

      try {

        System.err.println("find file length");

        int remoteFileLength = urlcon.getContentLength();

        parent.lP.setSize(remoteFileLength);

        System.err.println("file length "+remoteFileLength);



        System.err.println("get input stream");

        in =urlcon.getInputStream();

        //in = url.openStream();



	GZIPInputStream gzipin = new GZIPInputStream(in);




        /* download it */


        bytes_read=0;

        oneread=0;

	//        byte[] buffer = new byte[4096];

        byte[] buffer = new byte[16384];



        System.err.println("start reading...");



        while((bytes_read = gzipin.read(buffer)) != -1) {

                 updated=false;

                 out.write(buffer,0,bytes_read);

                 oneread += bytes_read;

                 parent.lP.showProgress(oneread);

                 

                 while(!updated) { 

                     iddle(10);

                 }

	  }

      }

      catch (Exception e) {System.err.println(e);}       


      finally {


        try{in.close(); out.close();} catch (Exception e){;}


      }

      parent.lP.showProgress(-1);

      parent.lP.dispose();

      parent.setDone(true);

  }



  public synchronized void iddle(long timeout) {

                 try {

                   wait(timeout);

		   //                parent.exeT.yield();

                 } catch (Exception e) {

                   System.err.println("ExeDownload.iddle: "+e);}

  }

  public void setUpdated() {
     updated=true;
  }
}
