import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class LoadModule extends JInternalFrame {

String selectedServer;
desktop d;
 JProgressBar progressBar;
 JTextField ta,ta1;

  public LoadModule(desktop d) {
  super("Module Administrator", true, true, true, true);
  this.d = d;
  
  this.selectedServer = d.selectedServer;


  JPanel bck = new JPanel();
  getContentPane().add(bck);

  bck.setLayout(new BorderLayout());
  JPanel titlePanel = new JPanel();
  titlePanel.setLayout(new GridLayout(4,1));
  titlePanel.add(new JLabel(" "));
  titlePanel.add(new JLabel("Configure modules", JLabel.CENTER));
  titlePanel.add(new JLabel(d.selectedServer, JLabel.CENTER));
  titlePanel.add(new JLabel(" "));
  bck.add(titlePanel,BorderLayout.NORTH);

     progressBar = new JProgressBar(0, 100);
     progressBar.setValue(0);
     progressBar.setStringPainted(true);

     /* messages */
     ta = new JTextField(20); 
     ta.setEditable(false);

     /* class names */
     ta1 = new JTextField(20); 
     ta1.setEditable(false);

     JTabbedPane tp = new JTabbedPane();

     JPanel tc = new JPanel();
     tc.setLayout(new GridLayout(3,1));

     JButton but = new JButton("update package WebFlow");
     but.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         downloadClasses("WebFlow");
       }
     });
     tc.add(but);

     JButton but1 = new JButton("update package WebFlow.event");
     but1.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         downloadClasses("WebFlow.event");
       }
     });
     tc.add(but1);

     JButton testIt = new JButton("test the Client");
     testIt.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         runSimpleClient();
       }
     });
     tc.add(testIt);  

   JPanel xmlPanel = new JPanel();
     xmlPanel.setLayout(new GridLayout(2,1));

     JButton but2 = new JButton("update package WebFlow.xml");
     but2.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         downloadClasses("WebFlow.xml");
       }
     });
     xmlPanel.add(but2);


     JButton testIt2 = new JButton("test the XML module");
     testIt2.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         String[] modules = new String[1];
         modules[0]="xml";
         runClient(modules);
       }
     });
     xmlPanel.add(testIt2);  


   JPanel sjPanel = new JPanel();
     sjPanel.setLayout(new GridLayout(2,1));

     JButton but3 = new JButton("update package WebFlow.submitJob");
     but3.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         downloadClasses("WebFlow.submitJob");
       }
     });
     sjPanel.add(but3);


     JButton testIt3 = new JButton("test submitJob module");
     testIt3.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         String[] modules = new String[1];
         modules[0]="submitJob";
         runClient(modules);
       }
     });
     sjPanel.add(testIt3);  

   JPanel ATDPanel = new JPanel();
     ATDPanel.setLayout(new GridLayout(2,1));

     JButton but4 = new JButton("update package WebFlow.ATD");
     but4.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         downloadClasses("WebFlow.ATD");
       }
     });
     ATDPanel.add(but4);


     JButton testIt4 = new JButton("test the ATD module");
     testIt4.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         String[] modules = new String[1];
         runCRPC();
       }
     });
     ATDPanel.add(testIt4);  
 
  tp.addTab("Test Client",tc);
  tp.addTab("ApplDesc Module",xmlPanel);
  tp.addTab("submitJob Module",sjPanel);
  tp.addTab("CRPC",ATDPanel);

  bck.add(tp, BorderLayout.CENTER);

  JPanel pb = new JPanel();
  pb.setLayout(new GridLayout(3,1));
  pb.add(progressBar);
  pb.add(ta);
  pb.add(ta1);
  
  bck.add(pb, BorderLayout.SOUTH);
  }

  public void downloadClasses(String s){
   updatePackages up = new updatePackages(d.WS_host,
                       "http://"+d.WS_host+":"+d.WS_port, this);
   Thread t = new Thread(up);
   up.setPackageName(s);
   t.start();
  }

  public void runSimpleClient() {
     CORBAclient client = new CORBAclient(d.IORfileURL);
     client.simpleClient();
  }

  public void runClient(String[] modules) {
     CORBAclient client = new CORBAclient(d.IORfileURL);
     client.Client(modules);
  }

  public void runCRPC() {
     CORBAclient client = new CORBAclient(d.IORfileURL);
     client.ClientCRPC("/npac/home/webflow/WEBFLOW/BeanContext_2.2.2/GatewayTest/Parssim.xml");
  }

  public  void setPBmaximum(int n){
    progressBar.setMaximum(n);
  }

  public  void setPBvalue(int n){
    progressBar.setValue(n);
  }
   
  public  void setClassName(String s) {
     ta1.setText(s);
  }

  public  void setPackageName(String s) {
     ta.setText(s);
  }

} 




