import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class MasterServerPanel extends JPanel {

String[] conf; //display,confFile,iorFile,classpath,servletURL,hashtable
String[] params;
JTextField[] s;
ActionListener[] al;
JPanel[] pp;
int n;
String ConfDir = ""; 
String ConfFileName;
desktop d;
String selectedServer;

  public MasterServerPanel(desktop d, String selectedServer) {

  this.d = d;
  this.selectedServer = selectedServer;
  n = d.n;
  conf = new String[n];
  for(int i=0;i<n;i++) {
     conf[i]="";
  }
  s = new JTextField[n];
  params = new String[6];
  params[0]="        Display ";
  params[1]="Master ConfFile ";
  params[2]="        IorFile ";
  params[3]="      ClassPath ";
  params[4]="     servletURL ";
  params[5]="  HashTableFile ";

  pp = new JPanel[n];
  al = new ActionListener[n];
  
  ConfFileName = ConfDir+selectedServer+".conf";

  File conffile = new File(ConfFileName);
  if(conffile.exists()) {
    try {
      FileReader fr = new FileReader(conffile);
      BufferedReader in = new BufferedReader(fr);
      String nextline = in.readLine();
      in.close();
      StringTokenizer st = new StringTokenizer(nextline,"+");
      for(int i=0; i<n; i++) {
        conf[i] = st.nextToken();
      }
      d.setServerConfig(conf);
   }
    catch (Exception e) {System.out.println(e);}
  }  
  else {
    System.out.println("new configuration");
  }


  setLayout(new BorderLayout());

  JPanel ss = new JPanel();
  ss.setLayout(new GridLayout(6,1));


     al[0] = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        setConf(0,e.getActionCommand());
     }
     };

     al[1] = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        setConf(1,e.getActionCommand());
     }
     };
     al[2] = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        setConf(2,e.getActionCommand());
     }
     };
     al[3] = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        setConf(3,e.getActionCommand());
     }
     };
     al[4] = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        setConf(4,e.getActionCommand());
     }
     };
     al[5] = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        setConf(5,e.getActionCommand());
     }
     };

  JLabel l;
  for (int i = 0; i<n; i++) {
     pp[i] = new JPanel();
     pp[i].setLayout(new BorderLayout());
     l = new JLabel(params[i]);
     l.setFont(new Font("Courier", Font.BOLD, 12));
     l.setForeground(Color.black);
     pp[i].add(l,BorderLayout.WEST);
     s[i] = new JTextField(conf[i],25);
     s[i].setPreferredSize(new Dimension(100,5));
     s[i].addActionListener(al[i]);
     pp[i].add(s[i],BorderLayout.CENTER);
     ss.add(pp[i]);  
  }

  add(ss,BorderLayout.CENTER);
  
  JPanel bp = new JPanel();
  bp.setLayout(new GridLayout(1,2));
  JButton b1 = new JButton("Commit");
  b1.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
       commit();
    }
  });
  bp.add(b1);

  JButton b2 = new JButton("Reset");
  b2.addActionListener(new ActionListener() {
    public void actionPerformed(ActionEvent e) {
       reset();
    }
  });
  bp.add(b2);
  add(bp,BorderLayout.SOUTH);
  
  }


  public void setConf(int i, String h) {
     conf[i]=h;
  } 

  public void commit() {
     d.setServerConfig(conf);
     try {    
        FileWriter fw = new FileWriter(ConfFileName);
        for (int i=0;i<n;i++) {
          if(conf[i].length()<1) fw.write("null+"); 
          else fw.write(conf[i]+"+");
        }
        fw.flush();
        fw.close();
     }
     catch (Exception e) { System.out.println(e);}
  }

  public void reset() {
    for(int i=0;i<n;i++) {
     conf[i]="";
     s[i].setText("");
    }
  }
}
