import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class ServerConfig extends JInternalFrame {

String selectedServer;
desktop d;

  public ServerConfig(desktop d) {
  super("Server Configuration", true, true, true, true);
  this.d = d;
  
  this.selectedServer = d.selectedServer;


  JPanel bck = new JPanel();
  getContentPane().add(bck);

  bck.setLayout(new BorderLayout());
  JPanel titlePanel = new JPanel();
  titlePanel.setLayout(new GridLayout(3,1));
  titlePanel.add(new JLabel(" "));
  titlePanel.add(new JLabel("Configure server "+d.selectedServer, JLabel.CENTER));
  titlePanel.add(new JLabel(" "));
  bck.add(titlePanel,BorderLayout.NORTH);

  JTabbedPane tp = new JTabbedPane();

  MasterServerPanel jp = new MasterServerPanel(d, selectedServer);
  WebServerPanel WebServer = new WebServerPanel(d, selectedServer);
  WebFlowServerPanel WebFlowServer = new WebFlowServerPanel(d, selectedServer);
  AADconfigPanel AADconfig = new AADconfigPanel(d, selectedServer); 
  JPanel Gateway = new JPanel();

  tp.addTab("Master Server",jp);
  tp.addTab("WebServer",WebServer);
  tp.addTab("WebFlowServer",WebFlowServer);
  tp.addTab("Applications",AADconfig);
  tp.addTab("Gateway",Gateway);

  bck.add(tp, BorderLayout.CENTER);  

  }

} 


