import javax.swing.*;
import java.awt.*;

public class loadProgress extends JFrame implements Runnable {

private Thread runner;
int taskSize;
int currSize, oldSize;
String taskName;
JLabel title;
JTextField status;
JProgressBar progressBar;
mapLoop parent;

  public loadProgress(String name, mapLoop parent) {
    super("load USGS data");
    this.parent = parent;
    taskSize=-1;
    taskName=name;

    title = new JLabel("download DEM data: "+taskName);
    status = new JTextField("contacting USGS web site",20);
    progressBar = new JProgressBar();
    progressBar.setMinimum(0);
    progressBar.setMaximum(100);
    progressBar.setValue(0);
    

    JPanel panel = new JPanel();
    panel.setLayout(new GridLayout(3,1));
    panel.add(title);
    panel.add(status); 
    panel.add(progressBar);

    panel.setBorder(BorderFactory.createEmptyBorder(20,20,20,20));
    Container c=getContentPane();
    c.add(panel);
    oldSize=0;
    currSize=1;
    System.err.println("initialization of loadProgress completed");
    //    start();
  }

  public void start() {
    if(runner==null) {
       runner = new Thread(this);
       runner.start(); 
    }
  }

    public synchronized void run() {
    status.setText("connecting...");
    progressBar.setValue(0);
    waitForSize();
    status.setText("downloading...");
    progressBar.setMaximum(taskSize*10);
    status.setText("file size is "+taskSize);
    
    while(currSize>0) {
       if(currSize > oldSize) {  
          progressBar.setValue(currSize);
          parent.exeDL.setUpdated();
          oldSize=currSize;
       }
       iddle(5);
    }


    }

  public void showProgress(int progress) {
      currSize=progress;
  }
  public void setSize(int newSize) {
     taskSize = newSize;
  }

  public synchronized void waitForSize(){
    while(taskSize<0){
      try {
        wait(100);
      }
      catch (Exception e) {System.err.println(e);}
    } 
 }
  public synchronized void iddle(long timeout){
    try {
        wait(timeout);
    }
    catch (Exception e) {System.err.println(e);} 
 }


}


